unit Unitx;

interface

uses
  Windows, SysUtils, Classes, Forms;


var
  _ExeName : string[255];
  _ExeDir : string[255];
  _ExeIni : string[255];

procedure XWriteToStringFile(S, FName: String);
procedure XWriteToNewStringFile(S, FName: String);

function binb(n: byte): string;
function IBox(s: string): integer;
function EBox(s: string): integer;
function QBox(s: string): integer;
function QBoxC(s: string): integer;
function SysErrMsg: string;
procedure WDelay(delay: integer);

implementation

{$I-}
procedure XWriteToStringFile(S, FName: String);
var f : text;
    e : integer;
begin
 assignfile(f,FName);
 append(f);
 e := IOResult;
 if e = 2 then
  begin
   rewrite(f);
   e := IOResult;
  end;
 if e in [0,183] then
  begin
   write(f,s);
   if IOResult <> 0 then
    begin
     messagebeep(0);
    end;
   closefile(f);
   if IOResult <> 0 then
    begin
     messagebeep(0);
    end;
  end;
end;

procedure XWriteToNewStringFile(S, FName: String);
begin
 if FileExists(FName) then
  begin
   if DeleteFile(FName) then XWriteToStringFile(S, FName);
  end else XWriteToStringFile(S, FName);
end;
{$I+}

function binb(n: byte): string;
var a, b: byte;
begin
 result := '';
 for a := 7 downto 0 do begin
  b := 1 shl a;
  result := result + Char(48 + Byte((Byte(n) and b) = b));
 end;
end;

procedure WDelay(delay: integer);
var n: tdatetime;
begin
 n := now+delay/(24*60*60*1000);
 while n > now do begin
  application.processmessages;
  sleepex(100,true);
 end;
end;

function SysErrMsg: string;
var r: dword;
begin
 r := GetLastError;
 result := format('%s [%d]',[SysErrorMessage(r),r]);
end;

function IBox(s: string): integer;
begin
 result := application.messagebox(PChar(s), 'Information', MB_TOPMOST + mb_iconinformation+mb_ok);
end;

function EBox(s: string): integer;
begin
 result :=  application.messagebox(PChar(s), 'Error', MB_TOPMOST+mb_iconStop+mb_ok);
end;

function QBox(s: string): integer;
begin
 result :=  application.messagebox(PChar(s), 'Question', MB_TOPMOST+mb_iconQuestion+mb_yesno);
end;

function QBoxC(s: string): integer;
begin
 result :=  application.messagebox(PChar(s), 'Question', MB_TOPMOST+mb_iconQuestion+mb_yesnocancel);
end;


procedure GetExePath;
var S: String;
    i: integer;
begin
 S := ExpandFileName(ParamStr(0));
 _ExeName := ExtractFileName(S);
 for i := length(_exename) downto 1 do
  begin
   if _exename[i] = '.' then
    begin
     _ExeName := Copy(_ExeName,1,i-1);
     break;
    end;
  end;
 _ExeDir := ExtractFilePath(S);
 _ExeIni := _ExeName+'.ini';
end;


initialization
 GetExePath;
 
end.